#if !defined(AFX_GRID_H__0F66B3A1_88A6_11D3_9886_0040056D374E__INCLUDED_)
#define AFX_GRID_H__0F66B3A1_88A6_11D3_9886_0040056D374E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Grid.h : header file
//

#include "BoggleDlg.h"
#include "Generation.h"
#include "Random.h"

#define ROWS	8
#define COLS	8
enum	FIND	{ FOUND, NOTFOUND };

/////////////////////////////////////////////////////////////////////////////
// CGrid window

class CGrid : public CStatic
{
	friend class	Generation<CGrid>;

public:
// Construction
	CGrid();
	CGrid(const CGrid &copy);	// copy ctor
	const CGrid& CGrid::operator=(const CGrid &right); // =

	// Implementation
	FIND FindString(CString s, int row, int col);
	FIND FindString(CString s);
	int DetermineFitness(void);
	int GetLetterCount(void) const;
	CGrid operator *(const CGrid &g);
	void Init();
	void Log();
	virtual ~CGrid();

// Attributes
private:
	// An 8x8 grid has a border of bogus chars all around (sentinels) so
	// it never has to check for borders--matches will always fail in the
	// borders.  Use rows 1-8 for real data, rows 0 and 9 have bogus chars.
	// (This uses more space but takes less time.)
	int				fitnessGrid[ROWS+2][COLS+2];	// Fitness numbers
	int				wordCnt;						// Number of words in grid
	int				letterCnt;						// Number of letters used in grid
	Random<char>	randomLetter;

	// Historical high water marks (only need one copy for all grids):
	static int		bestEverWords;
	static int		bestEverLetters;

public:
	char			letterGrid[ROWS+2][COLS+2];		// The actual grid

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGrid)
	//}}AFX_VIRTUAL

	// Generated message map functions
protected:
	//{{AFX_MSG(CGrid)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GRID_H__0F66B3A1_88A6_11D3_9886_0040056D374E__INCLUDED_)
